/***

Copyright 2011-2012 Carlos Moreno Muoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACIN DE CLASES
function Jugador (id){ 
	//Propiedades
	
	//ID
	this.id=id;
	
	//Cuerpo
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = 'imagenes/stickman.png';
	this.cuerpo_img[1]=new Image();
	this.cuerpo_img[1].src = 'imagenes/stickman2.png';
	this.cuerpo_width=10*ESCALA_GENERAL;
	this.cuerpo_height=20*ESCALA_GENERAL;
	this.xref=Math.round(this.cuerpo_width/2);
	this.yref=Math.round(this.cuerpo_height);
	
	//Cara
	this.cara_img=new Image();
	this.cara_img.src='imagenes/cara.png';
	this.cara_xref=-1*ESCALA_GENERAL;
	this.cara_yref=-8*ESCALA_GENERAL;
	this.cara_escala=0.05*ESCALA_GENERAL; //escala respecto al cuerpo
	
	//Rastro
	this.rastro_img=new Image();
	this.rastro_img.src = 'imagenes/rastro.png';
	this.xrastro;
	this.yrastro;
	this.rastro_tam=5*ESCALA_GENERAL;
	this.rastro_alpha=0.0;
	
	//Mtodos
	this.getX=function(){return posX+this.xref;}
	this.getY=function(){return posY+this.yref;}
	this.getCaraWidth=function(){return this.cara_img.width*this.cara_escala;};
	this.getCaraHeight=function(){return this.cara_img.height*this.cara_escala;};
	this.getXCara=function(){return posX+this.cara_xref;}
	this.getYCara=function(){return posY+this.cara_yref;}
}

function Escenario (id){ 
	//Propiedades 
	this.id=id;
	this.fondo_img=new Image();
	this.fondo_img.src = 'imagenes/fondo.png';
	this.xini=60*ESCALA_GENERAL;
	this.yini=60*ESCALA_GENERAL;
	
	this.area=new Array(3);
	this.area[0]=new Array(2);
	this.area[1]=new Array(2);
	this.area[2]=new Array(2);
	
	this.area[0][0]=Math.round(65*ESCALA_GENERAL);
	this.area[0][1]=Math.round(75*ESCALA_GENERAL);
	this.area[1][0]=Math.round(125*ESCALA_GENERAL);
	this.area[1][1]=Math.round(60*ESCALA_GENERAL);
	this.area[2][0]=Math.round(150*ESCALA_GENERAL);
	this.area[2][1]=this.area[1][1];
	
	//Objetos
	this.objetos=new Array(2);
	this.objetos[0]=new Objeto("guitarra",120,60,10,30);
	this.objetos[1]=new Objeto("telefono",44,53,15,10);	
}

function Ruta (xini,yini,xdes,ydes,area_actual,area_destino){
	//Propiedades 
	this.xcontrol;
	this.ycontrol;
	
	this.n_control=0;
	
	//Establecemos si hay riesgo de esquina
	if(area_actual!=area_destino){
		if(ydes<yini){ //Estoy subiendo
			if(area_destino<area_actual){ //Voy a la izquierda
				var xaux=xini;				
				if(escenario.area[area_destino][1]<escenario.area[area_actual][1]){ //El area es mayor
					while(posicion_relativa(escenario.area[area_destino][0],escenario.area[area_actual][1],xaux,yini,xdes,ydes)){
						xaux++;
					}
				}
					
				this.xcontrol=new Array(2);
				this.xcontrol[0]=xaux;
				this.xcontrol[1]=xdes;
				this.ycontrol=new Array(2);
				this.ycontrol[0]=yini;
				this.ycontrol[1]=ydes;
			}else{ //Voy a la derecha
				if(escenario.area[area_destino][1]<escenario.area[area_actual][1]){ //El area es mayor
					var xaux=xini;
					while(posicion_relativa(escenario.area[area_destino][0],escenario.area[area_actual][1],xaux,yini,xdes,ydes)){
						xaux++;
					}
					
					this.xcontrol=new Array(2);
					this.xcontrol[0]=xaux;
					this.xcontrol[1]=xdes;
					this.ycontrol=new Array(2);
					this.ycontrol[0]=yini;
					this.ycontrol[1]=ydes;
				}
			}
		}else{
			this.xcontrol=new Array(1);
			this.xcontrol[0]=xdes;
			this.ycontrol=new Array(1);
			this.ycontrol[0]=ydes;
		}
	}else{
		this.xcontrol=new Array(1);
		this.xcontrol[0]=xdes;
		this.ycontrol=new Array(1);
		this.ycontrol[0]=ydes;
	}
	
	this.finalizada=function(){
		if(this.n_control<this.xcontrol.length-1){
			this.n_control++;
			return false;
		}else return true;
	}

	this.getX=function(){return this.xcontrol[this.n_control];}
	this.getY=function(){return this.ycontrol[this.n_control];}
}

function Objeto(nombre,x,y,w,h){
	//Propiedades
	this.id=nombre;
	this.objeto_img=new Array(2);
	this.objeto_img[0]=new Image();
	this.objeto_img[0].src='imagenes/'+nombre+'.png';
	this.objeto_img[1]=new Image();
	this.objeto_img[1].src='imagenes/'+nombre+'2.png';
	this.x=x*ESCALA_GENERAL;
	this.y=y*ESCALA_GENERAL;
	this.width=w*ESCALA_GENERAL;
	this.height=h*ESCALA_GENERAL;
}

function Bocadillo(nombre,x,y,w,h){
	//Propiedades
	this.id=0;
        this.nombre=nombre;
	this.bocadillo_img=new Image();
	this.bocadillo_img.src='imagenes/bocadillo_'+nombre+'.png';
        this.x=x*ESCALA_GENERAL;
        this.y=y*ESCALA_GENERAL;
	this.width=w*ESCALA_GENERAL;
	this.height=h*ESCALA_GENERAL;
	this.bocadillo_alpha=0.0;
        this.estado=0;
        this.texto="";
	
	//Botn de cerrar
	this.cerrar_img=new Array(2);
	this.cerrar_img[0]=new Image();
	this.cerrar_img[0].src="imagenes/cerrar.png";
	this.cerrar_img[1]=new Image();
	this.cerrar_img[1].src="imagenes/cerrar2.png";
	this.cerrar_width=this.width/6;
	this.cerrar_height=this.cerrar_width;
	this.cerrar_x=this.x+this.width-this.cerrar_width;
	this.cerrar_y=this.y+this.cerrar_height;
}

function Boton(){
    this.image=new Image();
    this.image.src="imagenes/boton.png";
}

function Menu(w,h){
    this.botones=new Array(3);
    this.botones[0]=new Boton();
    this.botones[1]=new Boton();
    this.botones[2]=new Boton();
    this.width=w*ESCALA_GENERAL;
    this.height=h*ESCALA_GENERAL;
    
    this.estado=0;
        
    this.ancho_margen=10;
    var n_botones=this.botones.length;
    var tam_menu=n_botones*this.width + (n_botones-1)*this.ancho_margen;
    this.x=ANCHURA_VENTANA/2-tam_menu/2;
    this.y=0;
}